#! /usr/bin/perl -w
#
#  non-interactive version, edit param.input
#
use Getopt::Long;
#GetOptions("parameter=s" => \$paramfile, "zchar=s" => \$zstring);
GetOptions("parameter=s" => \$paramfile);
# default name:
unless ($paramfile) {
  $paramfile = "param.input";
}
# if verbose=1: make and ./comp.exe commands have to be done by user
$verbose=0;
#$exename="comp.exe";
#
%hash_var = ();
#@hash_var_keybasics = qw(comp dir); 
@hash_var_keyint = qw(N rank dim Feypars momentafile point); 
@hash_var_key=@hash_var_keyint;
$ivar = 0;
# read parameter input file and fill hash %hash_var
open (EREAD,$paramfile) || die "cannot open $paramfile";
#open (ET,">param_tmp");
while(<EREAD>) {
  chomp;
# chop white spaces at beginning of lines (and between words)
  s/^\s+//;
  unless (/^#/) {
    s/\s+//g; 
    $hash_var{$hash_var_key[$ivar]} = "$_";
#    print ET "$hash_var_key[$ivar]=$hash_var{$hash_var_key[$ivar]}\n";
    $ivar++;
  }
}
#close (ET);
close (EREAD);
# 
#$verbose=$hash_var{"verbose"};
$nlegs=$hash_var{"N"};
$rank=$hash_var{"rank"};
$dim=$hash_var{"dim"};
$momfile=$hash_var{"momentafile"};
#print "momfile=$momfile\n";
$point=$hash_var{"point"};
if ($rank != 0) {
@zlist=split(/,/,$hash_var{"Feypars"});
}
else {
@zlist=();
}
$zlength=@zlist;
#foreach $l (@zlist) {
#print "zi=$l\n";
#}
#
if ($dim eq "A") {
$dimvalue=4
}
elsif  ($dim eq "B") {
$dimvalue=6
}
elsif  ($dim eq "C") {
$dimvalue=8
}
else {
print "invalid type of form factor\n";
exit;
}
$rankFF=eval($rank-$dimvalue+4);
if ($dimvalue==6 and $rank<2) {
print "input error: B-type form factors start from rank 2\n";
exit;
}
if ($dimvalue==8 and $rank<4) {
print "input error: C-type form factors start from rank 4\n";
exit;
}
$help=eval($zlength-$rankFF-1);
#print "superfluous labels=$help\n";
for  (0 .. $help) {
#print "endofzlist=$#zlist\n";
$#zlist--;
}
#foreach $l (@zlist) {
#print "zi=$l\n";
#}
$zstring=join("z",@zlist );
#print "zstring=$zstring\n";
#print "zlength=$zlength\n";
#print "rankFF=$rankFF\n";
if ($zlength < $rankFF) {
print "input error:\n";
print "number of Feynman parameters in numerator should not be smaller than rank\n";
exit;
}
#
if ($rankFF==0) {
$namebase="N${nlegs}rank${rank}\_pt${point}";
}
else {
$namebase="N${nlegs}rank${rank}z${zstring}\_pt${point}";
}
#$fichier="testB52_boxes";
$fichier="${namebase}";
$outfile="${namebase}.out";
#$compfile="N${nlegs}rank${rank}noH\_pt${point}.numbers";
$compfile="N${nlegs}rank${rank}\_pt${point}.numbers";
print "calculating $nlegs-point form factors belonging to rank $rank\n";
if ($rankFF !=0) {
print "numerator z$zstring\n";
}
else {
print "no Feynman parameters in numerator \n";
}
#
if ($nlegs == 2) {
    print "direct tests of 2-point integrals not implemented\n";
    print "please choose 3,4,5 or 6 external legs\n";
}
if ($nlegs == 0) {
    $fichier = "demo_detg";
    print "test numerical stability\n";
}
#
#$maskfile="mask_${nlegs}point_pt${point}";
$maskfile="mask_${nlegs}point";
########### create f90 file according ot input ########
open(EWRITE,">temp") || die "cannot create temp";
open(EREAD,"$maskfile") || die "cannot read $maskfile";
#
while (<EREAD>) {
  chomp;
  if (/momentafile/) {
    s/momentafile/$momfile/;
  }
  if (/outfile/) {
    s/outfile/$outfile/;
  }
  if (/compfile/) {
    s/compfile/$compfile/;
  }
  if (/ndim=dim/) {
    s/ndim=dim/ndim=$dimvalue/;
  }
    if (/rank=rank/) {
    s/rank=rank/rank=$rank/;
    }
    if (/znum1/) {
       if ($rankFF > 0) {
       s/znum1/$zlist[0]/g;
       }
       else {s/znum1/0/g;}
    }
    if (/znum2/) {
      if ($rankFF > 1) {
      s/znum2/$zlist[1]/g;
      }
      else {s/znum2/0/g;}
    }
    if (/znum3/) {
      if ($rankFF > 2) {
      s/znum3/$zlist[2]/g;
      }
      else {s/znum3/0/g;}
    }
    if (/znum4/) {
      if ($rankFF > 3) {
      s/znum4/$zlist[3]/g;
      }
      else {s/znum4/0/g;}
    }
    if (/znum5/) {
      if ($rankFF > 4) {
      s/znum5/$zlist[4]/g;
      }
      else {s/znum5/0/g;}
    }
    if (/znum6/) {
      if ($rankFF > 5) {
      s/znum6/$zlist[5]/g;
      }
      else {s/znum6/0/g;}
    }
    print EWRITE "$_\n";
}
#
close(EREAD);
close(EWRITE);
#
system("mv temp $fichier.f90");
######################################################
# create file where plain Fortran result will be written to
open(EW,">>$compfile") || die "cannot create $compfile";
#print EW "N=$nlegs\n";
#print EW "rank=$rank\n";
#print EW "point=$point\n";
print EW "\n";
close(EW);
############ create Makefile ####################
open(EWRITE,">Make_temp") || die "cannot create Make_temp";
open(EREAD,"Makefile_proto") || die "cannot read Makefile_proto";
#
while (<EREAD>) {
  chomp;
  if (m/MAINC =/) {
    print EWRITE "MAINC =\t$fichier.o\n"
  }
  else {
    print EWRITE "$_\n";
  }
}
#
close(EREAD);
close(EWRITE);
#
system("mv Make_temp Makefile");
#
if ($verbose==1) {
print "The Makefile has been created\n";
print "Please, run:\n";
print "make\n";
print "./comp.exe\n"
}

######################################################################
# returns maximum value of a list of positive or zero numbers
sub maxoflist {
  my (@inputlist) = @_;
  $nbelements=@inputlist;
  $max=0;
#  print "$nbelements\n";
  for ($i=0;$i<$nbelements;$i++) {
    for ($j=$i;$j<$nbelements;$j++) {
       if ($inputlist[$j]>$max) {$max=$inputlist[$j]}
     }     
  }
  return($max); 
}
# returns minimum value of a list of positive or zero numbers
sub minoflist {
  my (@inputlist) = @_;
  $nbelements=@inputlist;
  $min=maxoflist(@inputlist);
  for ($i=0;$i<$nbelements-1;$i++) {
    for ($j=$i;$j<$nbelements;$j++) {
       if ($inputlist[$j]<$min) {$min=$inputlist[$j]}
#      print "$min\n"; 
     }     
  }
  return($min); 
}
# *********************************************************************

