#! /usr/bin/perl -w
#
# launch all z-numerators for a certain rank automatically
#
use Getopt::Long;
GetOptions("parameter=s" => \$paramfile);
# default name:
unless ($paramfile) {
  $paramfile = "param.input";
}
# file to generate random momenta
#$rambofile="mom_rambo.f";
#
# makenmerator.pl will read paramtemp; if only a particular 
# numerator should be calculated, paramtemp is equal to 
# the original input file
system("cp $paramfile paramtemp");
#$exename="comp.exe";
# flagexe =1 also runs make and comp.exe
$flagexe=1;
#
%hash_var = ();
@hash_var_keyint = qw(N rank dim Feypars momentafile point); 
@hash_var_key=@hash_var_keyint;
$ivar = 0;
# read parameter input file and fill hash %hash_var
open (EREAD,$paramfile) || die "cannot open $paramfile";
#open (ET,">param_tmp");
while(<EREAD>) {
  chomp;
# chop white spaces at beginning of lines (and between words)
  s/^\s+//;
  unless (/^#/) {
    s/\s+//g; 
    $hash_var{$hash_var_key[$ivar]} = "$_";
#    print ET "$hash_var_key[$ivar]=$hash_var{$hash_var_key[$ivar]}\n";
#    print  "$hash_var_key[$ivar]=$hash_var{$hash_var_key[$ivar]}\n";
    $ivar++;
  }
}
#close (ET);
close (EREAD);
# 
$nlegs=$hash_var{"N"};
$dim=$hash_var{"dim"};
$rank=$hash_var{"rank"};
print "number of legs=$nlegs, rank=$rank\n";
$momfile=$hash_var{"momentafile"};
print "momenta will be read in from $momfile\n";
$point=$hash_var{"point"};
$znum=$hash_var{"Feypars"};
if ($znum eq "all" || $znum eq "\"all\"") {
$flagall=1;
}
else {
$flagall=0;
@zlist=split(/,/,$hash_var{"Feypars"});
$jmax=@zlist;
}
if ($dim eq "A") {
$dimvalue=4;
print "A-type form factors\n";
}
elsif  ($dim eq "B") {
$dimvalue=6;
print "B-type form factors\n";
}
elsif  ($dim eq "C") {
$dimvalue=8;
print "C-type form factors\n";
}
else {
print "invalid type of form factor\n";
exit;
}
if ($nlegs eq 6 and $dim ne "A") {
print "please check form factor type, 6-point integrals only need type A form factors\n";
exit;
}
$rankFF=eval($rank-$dimvalue+4);
######### insert correct number of legs into mom_rambo.f #######
# skip, this is useless because momenta.dat should not
# be overwritten if user defined it by hand
#open(EWRITE,">rambotemp") || die "cannot create rambotemp";
#open(EREAD,"$rambofile") || die "cannot read $rambofile";
#
#$Nminusone=eval($nlegs-1);
#while (<EREAD>) {
#  chomp;
#  if (/nbmom\s*=\s*(\d)/) {
#    s/nbmom\s*=\s*($1)/nbmom=$Nminusone/;
#    }
#    print EWRITE "$_\n";
#}
#
#close(EREAD);
#close(EWRITE);
#system("mv rambotemp $rambofile");
#system("g77 $rambofile");
#system("a.out");
#
################### case all in one go ###########################
if ($flagall==1) {
@zlist1=(1 .. $nlegs);
@zlist2=();
@zlist3=();
@zlist4=();
@zlist5=();
@zlist6=();
$ct2=0;
for $j1 (1 .. $nlegs) { 
  for $j2 (1 .. $j1) { 
   $ct2++;
#   $zlist2[$j1-1][$j2-1] = "${j2},$j1"; 
   push(@zlist2,"${j2},$j1");
#   push(@strli2,"$j2$j1");
  } 
 }
# foreach $l (@zlist2) {
# print "l=$l\n";
# }
# print the whole list of lists one at a time 
#for $i ( 0 .. $#zlist2 ) { 
#  for $j ( 0 .. $#{$zlist2[$i]} ) { 
#  print "element $i $j is $zlist2[$i][$j]\n"; 
#  }
#}  
$ct3=0;
for $j1 (1 .. $nlegs) { 
  for $j2 (1 .. $j1) { 
    for $j3 (1 .. $j2) { 
    $ct3++;
#    $zlist3[$j1-1][$j2-1][$j3-1] = "$j3$j2$j1"; 
    push(@zlist3,"${j3},${j2},$j1");
#    push(@strli3,"$j3$j2$j1");
    }
   } 
 }
$ct4=0;
for $j1 (1 .. $nlegs) { 
  for $j2 (1 .. $j1) { 
    for $j3 (1 .. $j2) { 
      for $j4 (1 .. $j3) { 
      $ct4++;
#      $zlist4[$j1-1][$j2-1][$j3-1][$j4-1] = "$j4$j3$j2$j1"; 
      push(@zlist4,"${j4},${j3},${j2},$j1");
#      push(@strli4,"$j4$j3$j2$j1");
      }
     }
   } 
 }
$ct5=0;
for $j1 (1 .. $nlegs) { 
  for $j2 (1 .. $j1) { 
    for $j3 (1 .. $j2) { 
      for $j4 (1 .. $j3) { 
       for $j5 (1 .. $j4) { 
       $ct5++;
#       $zlist5[$j1-1][$j2-1][$j3-1][$j4-1][$j5-1] = "$j5$j4$j3$j2$j1"; 
       push(@zlist5,"${j5},${j4},${j3},${j2},$j1");
#       push(@strli5,"$j5$j4$j3$j2$j1");
      }
      }
     }
   } 
 }
$ct6=0;
for $j1 (1 .. $nlegs) { 
  for $j2 (1 .. $j1) { 
    for $j3 (1 .. $j2) { 
      for $j4 (1 .. $j3) { 
       for $j5 (1 .. $j4) { 
        for $j6 (1 .. $j5) { 
	$ct6++;
#        $zlist6[$j1-1][$j2-1][$j3-1][$j4-1][$j5-1][$j6-1] = "$j6$j5$j4$j3$j2$j1"; 
        push(@zlist6,"${j6},${j5},${j4},${j3},${j2},$j1");
#        push(@strli6,"$j6$j5$j4$j3$j2$j1");
        }
       }
      }
     }
   } 
 }
#
if ($rankFF==1) {
$jmax=$nlegs;
}
elsif ($rankFF==2) {
$jmax=$ct2;
print "nb of different z configurations is $ct2\n";
}
elsif ($rankFF==3) {
$jmax=$ct3;
print "nb of different z configurations is $ct3\n";}
elsif ($rankFF==4) {
$jmax=$ct4;
print "nb of different z configurations is $ct4\n";}
elsif ($rankFF==5) {
$jmax=$ct5;
print "nb of different z configurations is $ct5\n";}
elsif ($rankFF==6) {
$jmax=$ct6;
print "nb of different z configurations is $ct6\n";}
elsif ($rankFF==0) {
$jmax=1;
}
else {
print "invalid choice of rank\n";
exit;
}
#
#print "jmax=$jmax\n";
#$jmax=1;
########### create new input file ########
# 
for ($j=0;$j<$jmax;$j++) {
#$j=0;
open(EWRITE,">paramtemp") || die "cannot create paramtemp";
open(EREAD,"$paramfile") || die "cannot read $paramfile";
#
while (<EREAD>) {
  chomp;
  if ($rankFF==1) {
    if (/all/) {
    s/all/$zlist1[$j]/;
    }
  } # end if rank1  
  elsif ($rankFF==2) {
    if (/all/) {
    s/all/$zlist2[$j]/;
#     print "zlist52=$zlist2[$j]\n";
   }
  } # end if rank2  
  elsif ($rankFF==3) {
    if (/all/) {
    s/all/$zlist3[$j]/;
    }
  } # end if rank3  
  elsif ($rankFF==4) {
    if (/all/) {
    s/all/$zlist4[$j]/;
    }
  } # end if rank4  
  elsif ($rankFF==5) {
    if (/all/) {
    s/all/$zlist5[$j]/;
    }
  } # end if rank5  
  elsif ($rankFF==6) {
    if (/all/) {
    s/all/$zlist6[$j]/;
    }
  } # end if rank6  
  elsif ($rankFF==0) {
  s/all/0/;
  }
#
    print EWRITE "$_\n";
}
#
close(EREAD);
close(EWRITE);
#
#system("mv temp param.input");
 if ($flagexe==1) {
# create Makefile, compile and run
 system("perl makenumerator.pl --parameter paramtemp");
 system("make");
 system("./comp.exe");
 system("unlink paramtemp");
 } # end if flagexe=1
#
 } # end $j loop
} # end if flagall=1
######################################################
else { #flagall=0: only a particular numerator
 system("perl makenumerator.pl --parameter paramtemp");
 system("make");
 system("./comp.exe");
 system("unlink paramtemp");
}
print "the result is written to the files N${nlegs}rank${rank}*_pt${point}.out and N${nlegs}rank${rank}_pt${point}.numbers\n";


